/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: CamelCaseMatcher.java,v d808b6cb5d50 2010/07/10 21:19:33 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.taxonomy;

import javax.annotation.Nonnull;
import java.util.Locale;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class CamelCaseMatcher implements NameMatcher
  {
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public boolean matches (final @Nonnull String string,
                            final @Nonnull CharSequence match,
                            final @Nonnull Locale locale)
      {
        if (match.length() == 0)
          {
            return true;
          }

        final String lowerCaseString = string.toLowerCase(locale);
        final String lowerCaseMatch = match.toString().toLowerCase(locale);
        final String[] words = lowerCaseString.split(" ");

        if (match.length() > words.length)
          {
            return false;
          }

        for (int i = 0; i < match.length(); i++)
          {
            if (words[i].charAt(0) != lowerCaseMatch.charAt(i))
              {
                return false;
              }
          }

        return true;
      }
  }
